INTERFACE CodeGen;	(*27.01.2000 LB, based on NW, 17.11.94*)

	FROM Scanner IMPORT Symbol;
	IMPORT SIO;

	TYPE
		Mode	=	{Head, Var, Par, Const, Fld,
				 Typ, Proc, SProc, Reg, Jmp};
		Form	=	{Boolean, Integer, Array, Record};

		Object	=	REF RECORD
					class:	Mode;
					lev:	INTEGER;
					next, dsc: Object := NIL;
					type:	Type;
					name:	TEXT;
					val:	INTEGER;
				END; (*Object*)

		Type	=	REF RECORD
					form:	Form;
					fields:	Object := NIL;
					base:	Type;
					size, len:	INTEGER;
				END; (*Type*)

		Item	=	RECORD
					mode:	Mode;
					lev:	INTEGER;
					type:	Type:= NIL;
					a, b, r, idx: INTEGER;
				END; (*Item*)
	VAR
		boolType, intType:	Type;
			
	PROCEDURE IncLevel(n: INTEGER := 1);
	PROCEDURE MakeConstItem(VAR x: Item; type: Type; val: INTEGER);
	PROCEDURE MakeItem(VAR x: Item; y: Object);
	PROCEDURE Field(VAR x: Item; y: Object);
	PROCEDURE Index(VAR x, y: Item);
	PROCEDURE Op1(op: Symbol; VAR x: Item);
	PROCEDURE Op2(op: Symbol; VAR x, y: Item);
	PROCEDURE Relation(op: [Symbol.eql .. Symbol.geq]; VAR x, y: Item);
	PROCEDURE Store(VAR x, y: Item);
	PROCEDURE Parameter(VAR x: Item; ftype: Type; class: Mode);
	PROCEDURE TestBool(VAR x: Item);
	PROCEDURE TestBoolR(VAR x: Item; l: INTEGER);
	PROCEDURE BJump(l: INTEGER);
	PROCEDURE FJump(VAR l: INTEGER);
	PROCEDURE Call(VAR x: Item);
	PROCEDURE IOCall(VAR x, y: Item);
	PROCEDURE Enter(size: INTEGER);
	PROCEDURE Return(size: INTEGER);
	PROCEDURE CondFixup(L: INTEGER);
	PROCEDURE FixLink(L: INTEGER);
	PROCEDURE PC(): INTEGER;
	PROCEDURE CurrentLevel(): INTEGER;
	PROCEDURE Open();
	PROCEDURE Close();
	PROCEDURE LoadAndGo(trace, stepwise: BOOLEAN := TRUE; wr: SIO.Writer := NIL);
		  (*Executes code if required.
		    Generates an assembly file and writes it to "wr", if trace required*)

END CodeGen.