MODULE MiniComp EXPORTS Main;           (*27.01.2000 LB*)

	  IMPORT Parser, Scanner,	SIO, SF, Stdio, PParams;

	  CONST
	  		 Usage   = "-i InputFile | " & "-inputFile InputFile\n" &
		        		  " [-trace] [-t] [-s] [-stepwise]";
	  		 InExt   = ".pl0";
	  		 AsmExt  = ".asm";
	  		 ErrExt  = ".err";
	  		 DefName = "Test1";
	  VAR
	  		 fileName: TEXT := DefName;
	  		 inFile: SIO.Reader := NIL;
	  		 errFile: SIO.Writer := NIL;
	  		 asmFile: SIO.Writer := NIL;
	  		 trace, stepwise: BOOLEAN := FALSE;

	  PROCEDURE ParseCommandLine () RAISES {PParams.Error, SIO.Error} =
	  BEGIN
	  		 WITH
	  		 		pp = NEW(PParams.T).init(Stdio.stdout)
	  		 DO
	  		 		IF pp.keywordPresent("-i") OR pp.keywordPresent("-inputFile") THEN
	  		 			  fileName:= pp.getNext()
	  		 		END;
	  		 		inFile := SF.OpenRead(fileName & InExt);
	  		 		errFile := SF.OpenWrite(fileName & ErrExt, overwrite:= TRUE);
	  		 		asmFile := SF.OpenWrite(fileName & AsmExt, overwrite:= TRUE);
	  		 		IF pp.keywordPresent("-t") OR pp.keywordPresent("-trace") THEN
	  		 			  trace:= TRUE;
	  		 		END;
	  		 		IF pp.keywordPresent("-s") OR pp.keywordPresent("-stepwise") THEN
	  		 			  stepwise:= TRUE;
	  		 		END;
	  		 		pp.finish();
	  		 END; (*WITH pp*)
	  END ParseCommandLine;


BEGIN
	  SIO.PutText("Mini compiler starts compling ");
	  TRY
	  		 ParseCommandLine();
	  		 SIO.PutText(fileName & InExt);
	  		 Parser.Start(inFile, errFile, asmFile, trace, stepwise);
	  		 IF Scanner.Error() THEN
	  		 		SIO.PutLine("Syntatic errors in " & fileName & ErrExt &  ", sorry")
	  		 ELSE
	  		 		SIO.PutLine("Generated Symbolic code in " & fileName & AsmExt);
	  		 END; (*IF Scanner.Error*)
	  EXCEPT
	  |       PParams.Error   => SIO.PutLine("Proper Usage " & Usage);
	  |       SIO.Error       => SIO.PutLine("File error on " & fileName & InExt);
	  END; (*TRY*)
END MiniComp.
