INTERFACE VirtRisc;	(*27.01.2000 LB, based on NW, 17.11.94*)

IMPORT SIO, Word;

	TYPE 
		OpCode	=	{ADD, SUB, MUL, Div, Mod, CMP,
				 Or, And, BIC, XOR, SHL, SHA, CHK,
				 ADDI, SUBI, MULI, DIVI, MODI, CMPI,
				 ORI, ANDI, BICI, XORI, SHLI, SHAI, CHKI,
				 LDW, LDB, POP, STW, STB, PUSH,
				 BEQ, BNE, BLT, BGE, BLE, BGT, BSR,
				 JSI, JSR, RET, RD, WRD, WRH, WRC, EXT};
		Memory	=	ARRAY [0 .. (MemSize DIV WordSize) - 1] OF Word.T;
		Regs 	=	[0 .. NumRegs-1];
		RegSet	=	SET OF Regs;
		OpSet	=	SET OF OpCode;

	CONST
		K	=	1024;
		MemSize	=	16 * K;		(*in bytes*)
		NumRegs	=	32;		(*Number or registers*)
		WordSize =	4;		(*Word size in bytes*)
			(*!!!Word.T is supposed to be a 4-byte INTEGER!!!*)
		opL	=	6;		(*Length of op codes*)
		opPos	=	26;		(*Position of op codes*)
		aL	=	5;		(*Length of op a field*)
		aPos	=	21;		(*Positions of op a field*)
		bL	=	5;		(*Length of op b field*)
		bPos	=	16;		(*Position of op b field*)
		cL1	=	16;		(*Length of op c field except JSR*)
		cL2	=	26;		(*Length of op c field in JSR*)
		cPos	=	0;		(*Position of op c field*)
		b16	=	16_8000;	(*To check the sign bit of the 16-bit c field*)
		signE	=	16_10000;	(*Must be subtracted for sign extention*)


		FP	=	29;		(*Frame pointer register*)
		SP	=	30;		(*Stack pointer register*)
		RT	=	31;		(*Link register*)

		Vars	= OpSet {OpCode.ADD .. OpCode.SHA};	(*R.a:= R.b op R.c*)
		Cons	= OpSet {OpCode.ADDI .. OpCode.SHAI};	(*R.a:= R.b op c*)
		Checks	= OpSet {OpCode.CHK, OpCode.CHKI};	(*0 <= R.a < R.c; 0 <= R.a < c*)
		Mems	= OpSet {OpCode.LDW .. OpCode.PUSH};	
		(*R.a:= Mem[R.b + c] (pop: INC(R.b, c)),(push: DEC(R.b, c) Mem[R.b + c]:= R.a*)
		Branch	= OpSet {OpCode.BEQ .. OpCode.BGT};	(*Branch to c if R.a rel 0*)
		Calls	= OpSet {OpCode.BSR, OpCode.JSR, OpCode.RET};
		(*BSR: RT:= PC; Branch to PC + C; JSR:  RT:= PC; Branch to C; RET: Branch to C*)
		Read	= OpSet {OpCode.RD};			(*RD: R.a:= GetInt()*)	
		Writes	= OpSet {OpCode.WRD .. OpCode.WRC};	(*WRs: Put...(R.c)*)

		OpName	=	ARRAY OpCode OF TEXT 	
				{"ADD", "SUB", "MUL", "DIV", "MOD", "CMP",
				 "OR", "AND", "BIC", "XOR", "SHL", "SHA", "CHK",
				 "ADDI", "SUBI", "MULI", "DIVI", "MODI", "CMPI",
				 "ORI", "ANDI", "BICI", "XORI", "SHLI", "SHAI", "CHKI",
				 "LDW", "LDB", "POP", "STW", "STB", "PUSH",
				 "BEQ", "BNE", "BLT", "BGE", "BLE", "BGT", "BSR",
				 "JSI", "JSR", "RET", "READ", "WRD", "WRH", "WRC", "EXIT"};


	PROCEDURE Execute(VAR M: Memory; trace, stepwise: BOOLEAN:= FALSE;
		          pc: INTEGER; start: INTEGER := 0; wr: SIO.Writer := NIL);
		(*Executes the content of the memory with startadress "start".
		  Display instruction if trace is true 
		  and stops after every instruction, if stepwise is true.*)

END VirtRisc.